## cahirwpz-mimiker.zip

=== Makefile ===
# vim: tabstop=8 shiftwidth=8 noexpandtab:

TOPDIR = $(CURDIR)

# Directories which require calling make recursively
SUBDIR = sys lib bin usr.bin etc include contrib

all: install

build: setup
install: build
distclean: clean

format:
	./verify-format.sh --fix

bin-before: lib-install
usr.bin-before: lib-install
contrib-before: lib-install

# Detecting whether initrd.cpio requires rebuilding is tricky, because even if
# this target was to depend on $(shell find sysroot -type f), then make compares
# sysroot files timestamps BEFORE recursively entering bin and installing user
# programs into sysroot. This sounds silly, but apparently make assumes no files
# appear "without their explicit target". Thus, the only thing we can do is
# forcing make to always rebuild the archive.
initrd.cpio: bin-install usr.bin-install contrib-install
	@echo "[INITRD] Building $@..."
	cd sysroot && \
	  find -depth \( ! -name "*.dbg" -and -print \) | sort | \
	    $(CPIO) -o -R +0:+0 -F ../$@ 2> /dev/null

INSTALL-FILES += initrd.cpio
CLEAN-FILES += initrd.cpio

distclean-here:
	$(RM) -r sysroot

setup:
	$(MAKE) -C include setup

test: sys-build initrd.cpio
	./run_tests.py --board $(BOARD)

PHONY-TARGETS += setup test

IMGVER = 1.12.0
IMGNAME = cahirwpz/mimiker-ci

docker-build:
	docker build . -t $(IMGNAME):latest

docker-tag:
	docker image tag $(IMGNAME):latest $(IMGNAME):$(IMGVER)

docker-push:
	docker push $(IMGNAME):latest
	docker push $(IMGNAME):$(IMGVER)

PHONY-TARGETS += docker-build docker-tag docker-push

include $(TOPDIR)/build/common.mk

=== requirements.txt ===
pycodestyle == 2.10.0
pexpect == 4.8.0
fdt == 0.3.3
texttable == 1.6.7
libtmux == 0.15.8

=== bin/Makefile ===
# vim: tabstop=8 shiftwidth=8 noexpandtab:

TOPDIR = $(realpath ..)

SUBDIR = ksh mandelbrot ps \
	 sandbox setwinsize stty test_rtc tetris utest

all: build

include $(TOPDIR)/build/common.mk

=== contrib/Makefile ===
# vim: tabstop=8 shiftwidth=8 noexpandtab:

TOPDIR = $(realpath ..)

SUBDIR = atto lua sbase sinit ubase # doom mish evtest

all: build

include $(TOPDIR)/build/common.mk

=== etc/Makefile ===
# vim: tabstop=8 shiftwidth=8 noexpandtab:

TOPDIR = $(realpath ..)

FILES = group master.passwd rc.init rc.shutdown .kshrc shells
INSTALL-FILES = $(addprefix $(SYSROOT)/etc/, $(FILES))

all: build

include $(TOPDIR)/build/common.mk

$(SYSROOT)/etc/%: %
	echo "[INSTALL] $(DIR)$* -> /etc/$*"
	$(INSTALL) -m 644 -D $< $@

install-here:
	chmod 755 $(SYSROOT)/etc/rc.*

=== include/Makefile ===
# vim: tabstop=8 shiftwidth=8 noexpandtab:

TOPDIR = $(realpath ..)

HEADERS = $(wildcard *.h) $(foreach dir, machine sys, $(wildcard $(dir)/*.h))
INSTALL-FILES = $(addprefix $(SYSROOT)/usr/include/, $(HEADERS))

SOURCES_H = $(foreach dir, . dev aarch64 mips riscv sys, $(wildcard $(dir)/*.h))

all: build

include $(TOPDIR)/build/common.mk

setup: machine

machine: $(TOPDIR)/config.mk
	@echo "[SYMLINK] machine -> $(ARCH)"
	$(RM) machine
	$(LN) -s $(ARCH) machine

distclean-here:
	$(RM) -v machine

$(SYSROOT)/usr/include/%: %
	echo "[INSTALL] $(DIR)$* -> /usr/include/$*"
	$(INSTALL) -m 644 -D $< $@

=== lib/Makefile ===
# vim: tabstop=8 shiftwidth=8 noexpandtab:

TOPDIR = $(realpath ..)

SUBDIR = csu libc libm libterminfo libutil

all: build

include $(TOPDIR)/build/common.mk

=== sys/Makefile ===
# vim: tabstop=8 shiftwidth=8 noexpandtab:

TOPDIR = $(realpath ..)

include $(TOPDIR)/config.mk

SUBDIR = aarch64 contrib drv dts gen kern libkern mips riscv tests
KLIB = no

BUILD-FILES += $(KERNEL-IMAGES) mimiker.elf cscope.out etags tags
CLEAN-FILES += mimiker.elf.map

include $(TOPDIR)/build/build.kern.mk

LDSCRIPT = $(ARCH)/$(ARCH).ld
LDFLAGS += -T $(TOPDIR)/sys/$(LDSCRIPT)
LDLIBS	= --whole-archive $(KLIBLIST) --no-whole-archive

mimiker.elf: $(KLIBDEPS) $(LDSCRIPT)
	@echo "[LD] Linking kernel image: $@"
	$(LD) $(LDFLAGS) -Map=$@.map $(LDLIBS) -o $@

mimiker.img: mimiker.elf
	@echo "[OBJCOPY] Prepare kernel image: $@"
	$(OBJCOPY) -O binary $^ $@

mimiker.img.gz: mimiker.img
	@echo "[GZIP] Compress kernel image: $@"
	$(GZIP) -k -f $^ > $@

$(LDSCRIPT):
	make -C $(dir $(LDSCRIPT)) $(notdir $(LDSCRIPT))

# Lists of all files that we consider operating system kernel sources.
SRCDIRS = $(TOPDIR)/include $(TOPDIR)/sys
SRCFILES_C = $(shell find $(SRCDIRS) -iname '*.[ch]')
SRCFILES_ASM = $(shell find $(SRCDIRS) -iname '*.S')
SRCFILES = $(SRCFILES_C) $(SRCFILES_ASM)

cscope.out: $(SRCFILES)
	@echo "[CSCOPE] Rebuilding cscope database..."
	$(CSCOPE) $(SRCFILES)

etags tags:
	@echo "[CTAGS] Rebuilding tags database..."
	$(CTAGS) --language-force=c $(SRCFILES_C)
	$(CTAGS) --language-force=c -e -f etags $(SRCFILES_C)
	$(CTAGS) --language-force=asm -a $(SRCFILES_ASM)
	$(CTAGS) --language-force=asm -aef etags $(SRCFILES_ASM)

BUILD-FILES += cscope.out etags tags
CLEAN-FILES += *.taghl

=== usr.bin/Makefile ===
# vim: tabstop=8 shiftwidth=8 noexpandtab:

TOPDIR = $(realpath ..)

SUBDIR = script

all: build

include $(TOPDIR)/build/common.mk

=== bin/ksh/Makefile ===
TOPDIR = $(realpath ../..)

CPPFLAGS += -I.

PROGRAM = ksh
SOURCES = alloc.c c_ksh.c c_sh.c c_test.c c_ulimit.c edit.c emacs.c \
	eval.c exec.c expr.c history.c io.c jobs.c lex.c mail.c \
	main.c misc.c path.c shf.c sigact.c syn.c table.c trap.c \
	tree.c tty.c var.c version.c vi.c

all: build

clean-here:
	$(RM) siglist.out siglist.out.tmp
	$(RM) emacs.out emacs.out.tmp

install-here:
	@echo "[SYMLINK] sh -> $(PROGRAM)"
	ln -sf $(PROGRAM) $(SYSROOT)/$(BINDIR)/sh

# two steps to prevent the creation of a bogus siglist.out
siglist.out: config.h sh.h siglist.in siglist.sh
	./siglist.sh "$(CC) -E $(CPPFLAGS) $(DEFS) -I. -I$(CURDIR)" \
	    < $(CURDIR)/siglist.in > siglist.out.tmp \
	    && mv siglist.out.tmp siglist.out

# two steps to prevent the creation of a bogus emacs.out
emacs.out: emacs.c
	./emacs-gen.sh $(CURDIR)/emacs.c > emacs.out.tmp \
	    && mv emacs.out.tmp emacs.out

history.CFLAGS += -Wno-stringop-overflow

include $(TOPDIR)/build/build.prog.mk

=== bin/mandelbrot/Makefile ===
TOPDIR = $(realpath ../..)

PROGRAM = mandelbrot

include $(TOPDIR)/build/build.prog.mk

=== bin/ps/Makefile ===
TOPDIR = $(realpath ../..)

SCRIPT = ps

include $(TOPDIR)/build/build.script.mk

=== toolchain/openocd-mimiker/debian/changelog ===
openocd-mimiker (0.10.0+dev+mimiker1) unstable; urgency=medium

  * Setup hardware debugger for AArch64(RPi3)

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Sat, 15 Dec 2018 10:49:25 +0100

=== toolchain/qemu-mimiker/debian/changelog ===
qemu-mimiker (6.2.0+mimiker1) unstable; urgency=medium

  * Bump up simulator version.

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Thu, 21 Jul 2022 08:07:44 +0200

qemu-mimiker (6.0.0+mimiker2) unstable; urgency=medium

  * Add system simulator for 64-bit RISC-V.

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Wed, 20 Apr 2022 13:31:33 +0200

qemu-mimiker (6.0.0+mimiker1) unstable; urgency=medium

  * Bump up version.

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Mon, 07 Jun 2021 11:04:47 +0200

qemu-mimiker (4.2.1+mimiker3) unstable; urgency=medium

  * Add system simulator for AMD64.

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Mon, 29 Mar 2021 17:47:01 +0200

qemu-mimiker (4.2.1+mimiker2) unstable; urgency=medium

  * Add SIGXCPU handler in order to interrupt QEMU on timeout.

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Mon, 22 Mar 2021 08:41:23 +0100

qemu-mimiker (4.2.1+mimiker1) unstable; urgency=medium

  * Bump up version.

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Mon, 22 Feb 2021 20:51:53 +0100

qemu-mimiker (4.1.0+mimiker2) unstable; urgency=medium

  * Debugger can access all memory, even if CPU is in user mode.

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Mon, 18 Nov 2019 11:06:58 +0100

qemu-mimiker (4.1.0+mimiker1) unstable; urgency=medium

  * Updated to the most recent version.
 
 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Wed, 28 Aug 2019 12:54:28 +0200

qemu-mimiker (2.12.0+mimiker2) unstable; urgency=medium

  * Allow gdb to reach memory that cannot be translated using active TLB
    entries on MIPS architecture. QEMU performs page walk algorithm knowing
    internal behaviour of Mimiker kernel.

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Fri, 18 Jan 2019 11:32:24 +0100

qemu-mimiker (2.12.0+mimiker1) unstable; urgency=medium

  * Add system simulator for AArch64.

 -- Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>  Sat, 15 Dec 2018 10:49:25 +0100

=== toolchain/gnu/debian/control ===
Source: %{ARCH}-mimiker-elf
Section: unknown
Priority: optional
Maintainer: Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.8
Homepage: http://mimiker.ii.uni.wroc.pl

Package: %{ARCH}-mimiker-elf
Architecture: amd64
Depends: ${shlibs:Depends} ${misc:Depends}
Description: Mimiker OS toolchain for %{ARCH} architecture
 Toolchain for developing Mimiker operating system.  This package contains
 cross tools i.e. gcc, binutils, gdb targeted at %{ARCH} architecture.

=== toolchain/openocd-mimiker/debian/control ===
Source: openocd-mimiker
Section: embedded
Priority: optional
Maintainer: Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>
Build-Depends: debhelper (>= 9)
# Standards-Version: 3.9.8
Homepage: http://mimiker.ii.uni.wroc.pl

Package: openocd-mimiker
Architecture: amd64
Depends: ${shlibs:Depends}
Description: OpenOCD for Mimiker OS development.

=== toolchain/qemu-mimiker/debian/control ===
Source: qemu-mimiker
Section: unknown
Priority: optional
Maintainer: Krystian Bacławski <cahirwpz@cs.uni.wroc.pl>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.8
Homepage: http://mimiker.ii.uni.wroc.pl

Package: qemu-mimiker
Architecture: amd64
Depends: ${shlibs:Depends} ${misc:Depends}
Description: QEMU system simulator for Mimiker OS development
 This package contains modified QEMU system simulator for mipsel, aarch64,
 and riscv64 architectures.

=== toolchain/gnu/debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

build:
build-indep:
build-arch:

binary:
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_install
	dh_installman
	dh_link
	dh_strip -Xlibgcc.a -Xlibgcov.a
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep:
binary-arch:

clean:
	dh_clean

.PHONY: build clean binary-indep binary-arch binary install configure
